
function BidOnceAgain_OnLoad(self)
   print("Bid Once Again (Beta) loaded")
   self:RegisterEvent("LOOT_OPENED")
   self:RegisterEvent("CHAT_MSG_LOOT")
   self:RegisterEvent("RAID_ROSTER_UPDATE")
end

function BidOnceAgain_OnEvent(self, event, ...)
   -- Show the window
   -- ShowUIPanel(BidOnceAgainFrame)
   
   if event == "LOOT_OPENED" then
      BidOnceAgain_OnLootOpened(self)
   end
   if event == "RAID_ROSTER_UPDATE" then
      BidOnceAgain_OnRaidUpdate(self)
   end
   if event == "CHAT_MSG_LOOT" then
      BidOnceAgain_OnItemLootChat(...)
   end
end

function BidOnceAgain_OnLootOpened(self)
   for index = 1, GetNumLootItems() do
      local iconpath, name, quality = GetLootSlotInfo(index)
      local itemLink = GetLootSlotLink(index)
      local itemString = string.match(itemLink, "item:[%-?%d]+")
      local itemName, itemId = strsplit(":", itemString)
      -- Debug
      print("itemid=" .. itemId)
      if BOAStandings[itemId] then
         if AnnounceToRaidCheckButton:GetChecked() then
            SendChatMessage("BOA - Loot [" .. name .. "]", "RAID")
         else
            print("BOA - Loot [" .. name .. "]")
         end
         local bidList = "BidList:"
         for i = 1, #BOAStandings[itemId] do
            bidList = bidList .. BOAStandings[itemId][i] .. ", "
         end
         if AnnounceToRaidCheckButton:GetChecked() then
            SendChatMessage(bidList, "RAID")
         else
            print(bidList)
         end
         -- SendChatMessage(bidList, "RAID")
      end
   end
end

function BidOnceAgain_OnRaidUpdate(self)
   -- initialize the raid history if it's not already.
   if not BOARaidHistory then
      BOARaidHistory = {}
   end
   -- Get the current date.
   local weekday, month, day, year = CalendarGetDate()
   local dateKey = "" .. month .. "/" .. day .. "/" .. year
   print(dateKey)
end

function BidOnceAgain_OnItemLootChat(...)
   if not BOARaidHistory then
      BOARaidHistory = {}
   end
   -- Get the current date.
   local weekday, month, day, year = CalendarGetDate()
   local dateKey = "" .. month .. "/" .. day .. "/" .. year
   

      local msg, val2, val3, val4 = ...
      local itemString = string.match(msg, "item:[%-?%d]+")
      local itemName, itemId = strsplit(":", itemString)
      -- Debug
      print("itemid = ,," .. itemId)

      -- local desc, itemLink = strsplit(":", msg)
      -- print("msg:", itemLink )
      -- SendChatMessage(msg, "RAID")
end

function BidOnceAgain_OnImport(self)
   if not BOAStandings then
      BOAStandings = {}
   end
   local txt = BidOnceAgainFrameEditBox:GetText()
   BOAStandings.text = txt
   -- print("Data:" .. BOAStandings.text)
   local tempTbl = { strsplit("@", txt) }
   local itemId
   for i = 1, #tempTbl do
      -- Check for item and bids.
      if string.match(tempTbl[i], "item:") then
         -- Create item.
         local tag, id = strsplit(":", tempTbl[i])
         itemId = id
         BOAStandings[id] = { id=itemId }
      end
      if string.match(tempTbl[i], "bid:") then
         -- Create bid.
         local tag, owner, p = strsplit(":", tempTbl[i])
         table.insert(BOAStandings[itemId], owner)
      end

   end

   print("Standings data loaded.")
end


SLASH_BIDONCEAGAIN1 = "/boa"
SLASH_BIDONCEAGAIN2 = "/bidonceagain"
SlashCmdList["BIDONCEAGAIN"] = function(msg)
   ShowUIPanel(BidOnceAgainFrame)
end
